DROP TABLE HAS_OPTIONAL;
DROP TABLE HAS_SPAZI;
DROP TABLE PRENOTAZIONE;
DROP TABLE STANZA;
DROP TABLE AGENZIA;


-- create tables
CREATE TABLE AGENZIA (
    CodA INTEGER NOT NULL,
    SitoWeb VARCHAR(32),
    Tel VARCHAR(32) NOT NULL,
    Via_Indirizzo VARCHAR(32) NOT NULL,
    CAP_Indirizzo INTEGER NOT NULL,
    Citta_Indirizzo VARCHAR(32) NOT NULL,
    Numero_Indirizzo INTEGER NOT NULL,
    Stato_Indirizzo VARCHAR(32) NOT NULL,
    PRIMARY KEY (CodA)
);
CREATE TABLE STANZA (
    CodS INTEGER NOT NULL,
    Piano INTEGER NOT NULL,
    Superficie INTEGER NOT NULL,
    Type VARCHAR(32) NOT NULL,
    PRIMARY KEY (CodS)
);
CREATE TABLE PRENOTAZIONE (
    STANZA_CodS INTEGER NOT NULL,
    DataInizio VARCHAR(32) NOT NULL,
    DataFine VARCHAR(32) NOT NULL,
    Costo REAL NOT NULL,
    AGENZIA_CodA INTEGER NOT NULL,
    PRIMARY KEY (STANZA_CodS, DataInizio),
    FOREIGN KEY (STANZA_CodS) REFERENCES STANZA(CodS),
    FOREIGN KEY (AGENZIA_CodA) REFERENCES AGENZIA(CodA)
);
CREATE TABLE HAS_OPTIONAL (
    OPTIONAL_Optional VARCHAR(32) NOT NULL,
    STANZA_CodS INTEGER NOT NULL,
    PRIMARY KEY (OPTIONAL_Optional, STANZA_CodS),
    FOREIGN KEY (STANZA_CodS) REFERENCES STANZA(CodS)
);
CREATE TABLE HAS_SPAZI (
    SPAZI_Spazi VARCHAR(32) NOT NULL,
    STANZA_CodS INTEGER NOT NULL,
    PRIMARY KEY (SPAZI_Spazi, STANZA_CodS),
    FOREIGN KEY (STANZA_CodS) REFERENCES STANZA(CodS)
);